from machine import Pin,I2C,PWM
from hcsr04 import HCSR04
import ssd1306
import time 

i2c = I2C(scl=Pin(5), sda=Pin(4), freq=100000)     
olcd=ssd1306.SSD1306_I2C(128,64,i2c)

sensor = HCSR04(trigger_pin=13, echo_pin=12,echo_timeout_us=1000000)
sound = Pin(15,Pin.OUT)

def Display():
  tim = 20
  t = 0
  b = 0
  olcd.fill(0) 
  olcd.rect(4, 20, 120, 6, 1)
  olcd.rect(3, 19, 122, 8, 1)
  olcd.rect(2, 20, 2, 6, 1)
  olcd.rect(1, 21, 2, 4, 1)
  olcd.rect(125, 20, 2, 6, 1)
  olcd.rect(126, 21, 2, 4, 1)
  olcd.text(str(tim), 75, 40)
  olcd.text('washing..', 35, 5)
  olcd.text('time:', 35, 40)
  for a in range(5,125):
    olcd.line(a, 21, a, 24, 1)
    olcd.show()
    time.sleep_ms(150)  
    t = t + 1  
    if t >= 6:
      tim = tim - 1
      b = b + 1
      #time.sleep_ms(60)
      olcd.fill_rect(75, 40, 20, 20, 0)     
      olcd.text(str(tim), 75, 40)
      olcd.text( '.', 107, 5)  
      t = 0
      if tim < 1:   
        #time.sleep(1)
        olcd.fill_rect(75, 40, 20, 20, 0)
        olcd.text('ok', 75, 40)  
      if b >= 2:
        olcd.fill_rect(107, 5, 12, 12, 0)
        olcd.show()
        b = 0
        
  olcd.show()
        
def Display_wait():
  olcd.fill(0) 
  olcd.rect(4, 20, 120, 6, 1)
  olcd.rect(3, 19, 122, 8, 1)
  olcd.rect(2, 20, 1, 6, 1)
  olcd.rect(1, 21, 1, 4, 1)
  olcd.rect(125, 20, 2, 6, 1)
  olcd.rect(126, 21, 2, 4, 1)

  olcd.text('waiting...', 35, 5)
  olcd.text('Please wash', 20, 35)
  olcd.text('your hands', 22, 48)
  olcd.show()
  
try:
  while True:
    Display_wait()
    sound.value(1)
    distance = sensor.distance_cm()
    if distance < 20:
      sound.value(0)
      time.sleep_ms(400)
      sound.value(1)
      Display()
      for i in range(3):
        sound.value(0)
        time.sleep_ms(600)
        sound.value(1)
        time.sleep_ms(400)
      olcd.fill(0)
    
except KeyboardInterrupt:
          pass



